<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fn="http://www.w3.org/2005/02/xpath-function">

<xsl:key name="author" match="pub/author" use="@person"/>

<xsl:template match="/">
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="cv">

  <html>
    <head>
      <link rel="stylesheet" type="text/css" href="/mit.css"/>
      <title>Coauthors - <xsl:value-of select="name" /></title>
    </head>

    <body>

      <h1>Coauthors - <xsl:value-of select="name" /></h1>

      <div class="box">
        <b>Total coauthors</b>: <xsl:value-of select="count(//person[@id != 'adamc' and count(key('author', @id)) > 0])"/>
      </div>

      <div class="box">
        <h2>All Coauthors</h2>

        <xsl:for-each select="person">
          <xsl:sort data-type="number" select="count(key('author', @id))" order="descending" />
          <xsl:sort select="name/text()" />

          <xsl:if test="@id != 'adamc' and count(key('author', @id)) > 0">
	    <li>
              <a href="{url}"><xsl:value-of select="name/text()" /></a>:
              <xsl:value-of select="count(key('author', @id))"/>
            </li>
          </xsl:if>
        </xsl:for-each>
      </div>
    </body>
  </html>

</xsl:template>

</xsl:stylesheet>
